﻿Option Strict On
Option Explicit On
Public Class Form1
    Dim idx As Int32
    Dim ptStart As New Point(10, 20)
    Dim szButton As New Size(115, 34)

    Dim lstLabels As New List(Of Label)
    Dim lstButtons As New List(Of Button)
    Private Sub Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        'Für alle Buttons den gleichen Click Event
        If TypeOf sender Is Button Then
            MessageBox.Show(DirectCast(sender, Button).Name & " was clicked")
        End If
    End Sub
    Private Sub btnCreate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCreate.Click
        CreateLabelsAndButtons()
    End Sub
    Private Sub Form1_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        Me.btnDelete.PerformClick()
    End Sub
    Private Sub btnDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        For i As Int32 = 0 To lstButtons.Count - 1
            With lstButtons(i)
                RemoveHandler .Click, AddressOf Button_Click
                Me.sp1.Panel1.Controls.Remove(lstButtons(i))
                .Dispose()
            End With
            With lstLabels(i)
                Me.sp1.Panel1.Controls.Remove(lstLabels(i))
                .Dispose()
            End With
        Next
        lstLabels.Clear()
        lstButtons.Clear()
        Me.idx = 0
    End Sub
    Private Function GetX(ByVal bol As Boolean) As Int32
        If bol Then 'True gleich Label
            Return If((idx And 1) = 0, ptStart.X, 270)
        End If
        Return If((Me.idx And 1) = 0, _
                   Me.ptStart.X + Me.lstLabels(idx).Width + 15, _
                   Me.lstLabels(idx).Location.X + Me.lstLabels(idx).Width + 15)
    End Function
    Private Function GetY(ByVal bol As Boolean) As Int32
        If bol Then 'True gleich Label
            Return ptStart.Y - Me.sp1.Panel1.VerticalScroll.Value + (idx \ 2) * 35
        End If
        Return (ptStart.Y - 6) - Me.sp1.Panel1.VerticalScroll.Value + (idx \ 2) * 35
    End Function
    Private Function CreateButton() As Button
        Dim btn As New Button
        With btn
            .Size = szButton
            .Name = "Button_" & Me.idx.ToString
            .Text = "Button " & Me.idx.ToString
            .Location = New Point(GetX(False), GetY(False))
            AddHandler .Click, AddressOf Button_Click
        End With
        Return btn
    End Function
    Private Function CreateLabel() As Label
        Dim Lb As New Label
        With Lb
            .Name = "Label_" & Me.idx.ToString
            .Text = "Label " & Me.idx.ToString
            .Location = New Point(GetX(True), GetY(True))
        End With
        Return Lb
    End Function
    Private Sub CreateLabelsAndButtons()
        Me.lstLabels.Add(Me.CreateLabel()) : Me.lstButtons.Add(Me.CreateButton()) : idx += 1
        Me.lstLabels.Add(Me.CreateLabel()) : Me.lstButtons.Add(Me.CreateButton())
        Me.SuspendLayout()
        With Me.sp1.Panel1
            .Controls.Add(Me.lstLabels(Me.idx - 1))
            .Controls.Add(Me.lstLabels(Me.idx))
            .Controls.Add(Me.lstButtons(Me.idx - 1))
            .Controls.Add(Me.lstButtons(Me.idx))
        End With
        Me.ResumeLayout(False)
        idx += 1
    End Sub
    Public Sub New()
        MyBase.New()
        InitializeComponent()
        Me.sp1.Panel1.AutoScroll = True
        Me.idx = 0
    End Sub
End Class
